<template>
	<div class="flex flex-col px-4">
		<div class="flex justify-between w-full" :class="[isEurope ? 'mb-1' : '']">
			<p class="font-primary-font-bold text-black">Order total</p>
			<p class="font-primary-font-bold text-black"
				>{{ currencyDisplay }}{{ TOTAL_PRICE | centsToDollars | zeroDisplay | formatPrice }}
			</p>
		</div>
		<p v-if="isEurope" class="font-primary-font-regular text-black text-sm leading-6">Including VAT</p>
		<div v-if="GIFT" class="flex justify-between w-full">
			<p>This is a gift</p>
			<MkGiftIcon />
		</div>
		<div v-if="showCheckBox" class="flex mt-10">
			<MkCheck
				:checked="checkBox"
				aria-label="Accept our terms of service, privacy policy and auto-refill terms."
				radio-title=""
				@change="accepted"
			/>
			<span>
				Accept our
				<strong><a href="https://molekule.com/legal#terms" class="mk-link" target="_blank">terms of service</a></strong
				><span>{{ comma }}</span>
				<strong><a href="https://molekule.com/legal#privacy" target="_blank" class="mk-link">privacy policy</a></strong>
				<span v-if="!GIFT && !isEurope">and </span>
				<strong
					><a v-if="!GIFT && !isEurope" href="https://molekule.com/legal#AutoRefills" target="_blank" class="mk-link"
						>auto-refill terms.</a
					></strong
				>
			</span>
		</div>
		<p v-if="showDisclaimer" class="font-primary-font-light-italic text-base leading-6 mt-6 md:mt-8 lg:mt-10">
			Filter auto-refills: Filters automatically renew and ship at the end of each refill period. At renewal, you will
			be charged the same amount and for the same duration. You can
			<button
				ref="cancel_link"
				class="font-primary-font-bold-italic md:font-primary-font-bold text-base leading-6 cursor-pointer focus:outline-none focus:ring-1 focus:ring-black"
				@click="showPopup()"
				@keypress.enter="showPopup"
			>
				cancel
			</button>
			at any time in your account.
		</p>
		<p
			v-if="paymentData && paymentData.selectedAffirm"
			ref="affirmContent"
			role="alert"
			aria-live="polite"
			class="font-primary-font-light-italic text-base leading-6 mt-6 md:mt-8 lg:mt-10"
		>
			Using Affirm will move you through a quick approval process and return you here if your order is confirmed.
		</p>
		<p v-if="error && isCheckout" role="alert" class="text-error-20">
			{{ errorText || 'Please provide all the required fields' }}
		</p>
		<MkSecondaryButton
			:loading="orderLoading"
			class="flex justify-center items-center mt-8 lg:mt-10"
			mksecondary-width="w-full md:w-cart-register-md-inner lg:w-full"
			:button-title="isCheckout ? 'Place order' : 'Proceed to checkout'"
			@click="submit()"
			@keypress.enter="submit()"
		/>
		<MkStripeIcon :name="paymentIcon" class="w-119 m-auto mt-6" />
		<MkModal
			v-if="showModal && cancelModal"
			handel-shift-tab
			:toggle-modal="cancelModal && showModal"
			model-class="max-w-full md:max-w-md lg:max-w-xl items-center"
			modal-height="h-auto"
			@close-modal="closeModal"
		>
			<template #modalContent>
				<p class="font-primary-font-regular text-base">
					You can cancel or make changes to your auto-refill schedule in your account under Options. Changes to your
					auto-refill schedule must be made at least 1 day prior to your renewal date to avoid billing for the next
					renewal period. If you decide to stop auto-refills, you will continue to receive any shipments still
					outstanding in your current renewal period but will not be billed for another renewal period.
				</p>
			</template>
		</MkModal>
	</div>
</template>
<script>
import { mapState } from 'vuex';
import MkGiftIcon from '~/components/D2C/atoms/MkGiftIcon.vue';
import MkSecondaryButton from '~/components/D2C/atoms/MkSecondaryButton.vue';
import MkModal from '~/components/D2C/molecules/MkModal.vue';
import MkCheck from '~/components/D2C/atoms/MkCheck.vue';
import MkStripeIcon from '~/components/D2C/atoms/MkStripeIcon.vue';
export default {
	name: 'MkOrderCheckout',
	components: { MkGiftIcon, MkSecondaryButton, MkModal, MkCheck, MkStripeIcon },
	props: {
		isCheckout: {
			type: Boolean,
			default: false,
		},
		isAffrim: {
			type: Boolean,
			default: false,
		},
		paymentData: {
			type: Object,
			default: () => {},
		},
	},
	data() {
		return {
			orderLoading: false,
			cancelModal: false,
			error: false,
			disableTrue: false,
			formData: {},
			comma: ',',
			checkBox: false,
			apiCall: false,
			billingAddress: {},
			hasSubscription: false,
			errorText: '',
		};
	},
	computed: {
		...mapState(['currencyDisplay', 'isEurope', 'apiLocale']),
		...mapState('CART_STORE', [
			'TOTAL_PRICE',
			'CART_ID',
			'GIFT',
			'LINE_ITEMS',
			'CART',
			'GUEST_USER',
			'ANONYMOUS_ID',
			'HAS_SUBSCRIPTION_PRODUCT',
		]),
		...mapState('ADYEN_STORE', ['CARD_DETAILS']),
		...mapState('USER_STORE', ['AUTHENTICATED', 'USER_EXIST', 'ACCEPT_CONDITION']),
		...mapState(['isEurope']),
		showModal() {
			return this.$store.state.MODAL_STORE.IS_ACTIVE;
		},
		showDisclaimer() {
			return (
				this.HAS_SUBSCRIPTION_PRODUCT &&
				this.isCheckout &&
				!this.GIFT &&
				!(this.paymentData && this.paymentData.selectedAffirm) &&
				((!this.USER_EXIST && !this.AUTHENTICATED) || this.AUTHENTICATED) &&
				!this.isEurope
			);
		},
		showCheckBox() {
			return this.AUTHENTICATED && this.isCheckout;
		},
		paymentIcon() {
			if (this.isEurope) {
				return 'adyen-logo.svg';
			} else {
				return 'd-2-c-icons-general-stripe-logo.svg';
			}
		},
	},
	watch: {
		paymentData: {
			deep: true,
			handler() {
				this.checkDataFilled();
			},
		},
		GIFT: {
			deep: true,
			handler() {
				this.updateMessage(this.GIFT);
			},
		},
	},
	mounted() {
		if (this.GIFT) {
			this.updateMessage(this.GIFT);
		}
		if (this.isEurope) {
			this.updateMessage(this.isEurope);
		}
	},
	methods: {
		closeModal() {
			this.cancelModal = false;
			this.$root.$utility.elementFocus(this, 'cancel_link');
		},
		checkDataFilled() {
			this.billingAddress = this.paymentData.addressData;
			if (!this.paymentData.useBillingAddress) {
				if (
					this.billingAddress.streetAddress1 &&
					this.billingAddress.city &&
					this.billingAddress.country &&
					this.billingAddress.firstName &&
					this.billingAddress.lastName &&
					this.billingAddress.phoneNumber &&
					this.billingAddress.postalCode &&
					(this.isEurope ? true : this.billingAddress.state)
				) {
					this.disableTrue = false;
				} else {
					this.disableTrue = true;
				}
			} else {
				this.disableTrue = false;
			}
		},
		async submit() {
			this.error = false;
			this.errorText = '';
			if (!this.checkBox && this.showCheckBox) {
				this.error = true;
				return;
			}
			if (this.isCheckout) {
				// const query = this.$route.query
				// query['gift'] = this.giftEnabled;
				this.orderLoading = true;
				const $obj = {};
				this.billingAddress.streetName = this.billingAddress.streetAddress1;
				this.billingAddress.streetNumber = this.billingAddress.streetAddress2;
				if (this.GUEST_USER) {
					if (this.paymentData.selectedAffirm) {
						const $items = [];
						this.hasSubscription = false;
						for (let $i = 0; $i < this.LINE_ITEMS.length; $i++) {
							$items.push({
								display_name: this.LINE_ITEMS[$i].name[this.apiLocale],
								sku: this.LINE_ITEMS[$i].variant.sku,
								unit_price: this.$root.$utility.centsToDollarsConvert(this.LINE_ITEMS[$i].price.value.centAmount),
								qty: this.LINE_ITEMS[$i].quantity,
							});
						}
						await this.$affirmAurora.checkoutAffirm({
							items: $items,
							billingAddress: this.billingAddress,
							cart: this.CART,
						});
						await this.$affirmAurora.openAffirm({}, this.affirmRes);
					} else {
						let paymentIntentId;

						if (this.isEurope) {
							const adyenCardDetails = this.CARD_DETAILS;

							if (!Object.keys(adyenCardDetails).length) {
								this.orderLoading = false;
								this.error = true;
								return;
							}

							delete adyenCardDetails.type;
							delete adyenCardDetails.brand;

							const payload = {
								amount: this.TOTAL_PRICE.toString(),
								...adyenCardDetails,
							};

							if (this.GUEST_USER) {
								payload.cartId = this.CART_ID;
							} else {
								payload.customerId = this.ANONYMOUS_ID;
							}
							paymentIntentId = '';
							try {
								paymentIntentId = await this.$repositories.checkout
									.setupPaymentToken(payload) // eslint-disable-line
									.then((res) => {
										const token = res?.data?.recurringDetailReference;
										if (!token) {
											this.$store.dispatch('ADYEN_STORE/CARD_VALIDATION', {
												error: res?.data,
											});
										} else {
											return token;
										}
									});
							} catch (exp) {
								this.orderLoading = false;
								this.error = true;
							}
						} else {
							const intentCallResponse = await this.$repositories.checkout.setupPaymentToken({
								paymentKeyOnly: true,
								customerId: this.ANONYMOUS_ID,
							});
							const clientSecret = (intentCallResponse.data && intentCallResponse.data.clientSecret) || '';
							paymentIntentId = '';
							try {
								paymentIntentId = await getPaymentIntent(clientSecret); // eslint-disable-line
							} catch (exp) {
								this.orderLoading = false;
								this.error = true;
							}
						}
						if (paymentIntentId) {
							let placeOrderData = {
								paymentToken: paymentIntentId,
								billingAddress:
									this.paymentData.addressData && this.paymentData.addressData.firstName
										? this.billingAddress
										: this.CART.shippingAddress,
							};
							if (this.isEurope) {
								placeOrderData = { ...placeOrderData, ...this.ACCEPT_CONDITION };
							}
							this.placeOrder(placeOrderData);
						} else {
							this.orderLoading = false;
							this.error = true;
						}
					}
				} else {
					if (
						((this.paymentData && this.paymentData.selectedCard && this.paymentData.selectedCard.paymentToken) ||
							this.paymentData.selectedAffirm) &&
						!this.disableTrue
					) {
						$obj.paymentToken = this.paymentData.selectedCard.paymentToken;
						if (this.isEurope) {
							$obj.billingAddress =
								this.paymentData.addressData && this.paymentData.addressData.firstName
									? this.billingAddress
									: this.CART.shippingAddress;
						}
						this.errorText = '';
						this.error = false;
					} else {
						this.error = true;
						this.orderLoading = false;
						return;
					}
					if (this.paymentData.selectedAffirm) {
						const $items = [];
						this.hasSubscription = false;
						for (let $i = 0; $i < this.LINE_ITEMS.length; $i++) {
							if (!this.hasSubscription) {
								this.hasSubscription = this.LINE_ITEMS[$i].cartItemHasSubscription;
							}
							$items.push({
								display_name: this.LINE_ITEMS[$i].name[this.apiLocale],
								sku: this.LINE_ITEMS[$i].variant.sku,
								unit_price: this.$root.$utility.centsToDollarsConvert(this.LINE_ITEMS[$i].price.value.centAmount),
								qty: this.LINE_ITEMS[$i].quantity,
							});
						}
						await this.$affirmAurora.checkoutAffirm({
							items: $items,
							billingAddress: this.billingAddress,
							cart: this.CART,
						});
						await this.$affirmAurora.openAffirm({}, this.affirmRes);
					} else if (!this.paymentData.useBillingAddress && !this.paymentData.selectedAffirm) {
						this.apiCall = true;
						const data = {};
						data.action = 'UPDATE_PAYMENT';
						data.billingAddress = this.paymentData.addressData;
						data.billingAddress.streetName = data.billingAddress.streetAddress1;
						data.billingAddress.streetNumber = data.billingAddress.streetAddress2;
						data.isDefaultPayment = false;
						data.paymentToken = this.paymentData.paymentToken || this.paymentData?.selectedCard?.paymentToken;
						data.paymentId = this.paymentData.paymentId || this.paymentData?.selectedCard?.paymentId;
						data.paymentType = 'CREDITCARD';
						await this.$store.dispatch('USER_STORE/UPDATE_CUSTOMER_BY_ID', data);
						this.apiCall = false;
					}
					if (!this.apiCall && !this.paymentData.selectedAffirm) {
						delete $obj.paymentType;
						this.placeOrder($obj);
					}
					// this.paymentData // creditcard payment detail

					// this.$router.push({path:'/D2C/orderSuccess/'})
				}
			} else {
				this.$router.push('/D2C/checkout/');
			}
		},
		affirmRes($token) {
			const $obj = {
				paymentType: 'AFFIRM',
				paymentToken: $token,
			};
			this.placeOrder($obj);
		},
		async placeOrder($obj) {
			$obj.cartId = this.CART_ID;
			let objPayload = { ...$obj };
			const adyenCardDetails = this.CARD_DETAILS;
			if (this.isEurope && this.GUEST_USER) {
				if (Object.keys(adyenCardDetails).length !== 0) {
					delete adyenCardDetails.type;
					delete adyenCardDetails.brand;
				}
				objPayload = { ...objPayload, ...this.CARD_DETAILS };
			}
			const $response = await this.$repositories.checkout
				.placeOrder(objPayload)
				.then((res) => {
					if (!res?.data?.recurringDetailReference && (res?.data?.errorCode || res?.data?.resultCode)) {
						this.errorText = res?.data?.message || res?.data?.refusalReason;
						this.error = true;
					}
					return res;
				})
				.catch(() => {
					this.$store.dispatch('CART_STORE/API_SERVICE_ERROR', true);
					return {};
				});
			if ($response.data && $response.data.id) {
				sessionStorage.removeItem('cartId');
				this.$store.commit('CHECKOUT_STORE/RESET_CHECKOUT');
				this.$store.commit('CART_STORE/EMPTY_CART');
				let successUrl = `/D2C/checkout/orderSuccess?order=${$response.data.id}`;
				if (this.hasSubscription && !this.GUEST_USER) {
					successUrl = `/D2C/checkout/affirmPayment?order=${$response.data.id}&customer=${$response.data.customerId}`;
				}
				if (this.hasSubscription && this.GUEST_USER) {
					successUrl = `/D2C/checkout/orderSuccess?order=${$response.data.id}&status=inactive`;
				}
				if (window) {
					window.location.href = successUrl;
				} else {
					this.$router.push(successUrl);
				}
			} else {
				this.$store.dispatch('CART_STORE/API_SERVICE_ERROR', true);
			}
			this.orderLoading = false;
		},
		showPopup() {
			this.cancelModal = true;
			this.$store.commit('MODAL_STORE/TOGGLE_MODAL');
		},
		accepted() {
			this.checkBox = !this.checkBox;
		},
		updateMessage(value) {
			this.comma = value ? ' and ' : ',';
		},
	},
};
</script>
